#include "bcd.h"
#include "alati.h"
#include "rezultat.h"
using namespace std;

		BcdBroj::BcdBroj() {}
		int BcdBroj::Duzina() const
		{
			return _Broj.size();
		}
		char BcdBroj::VratiCifru (const int i) const
		{
			return _Broj[i];
		}
		char BcdBroj::Znak() const
		{
			return _Znak;
		}
		BcdBroj::operator string() const
		{
			return _Broj;
		}
		void BcdBroj::IzvrsiOperaciju (BcdBroj& x)
		{
			x.Skrati();						//Brisemo eventualne vodece nule
			(*this).Skrati();
			
			if (x.Duzina() == 0)			//Ako je neki od brojeva bas nula
				x.KorigujBcdBroj(4);		//korigujemo ga da sadrzi bar jednu
			if ((*this).Duzina() == 0)		//cifru - nulu
				KorigujBcdBroj(4);
			
			if (Znak() == x.Znak()) //znakovi su jednaki pa vrsimo sabiranje
				(*this).SaberiSa(x, Znak());

			else if (Duzina() != x.Duzina()) //imaju razlicit broj cifara pa od onog sa vecim brojem cifara oduzimamo
			{
				if (Duzina() > x.Duzina())   //onaj sa manjim, i znak duzeg dodeljujemo rezultatu
					x.OduzmiOd(*this, Znak());
				else
					(*this).OduzmiOd(x, x.Znak());
			}

			else //iste su duzine pa ce znak rezultata zavisiti od prvog bita sa leve strane u kojem se operandi
			{    //razlikuju, znak ce biti od onog koji ima 1 na tom mestu
				int i=0;
				while ((VratiCifru(i) == x.VratiCifru(i)) && i!=Duzina())
					i++;
				if (i == Duzina()) //To su isti brojevi sa suprotnim znacima
					x.OduzmiOd(*this, '+');
				else if (VratiCifru(i) > x.VratiCifru(i))
					x.OduzmiOd(*this,Znak());
				else
					(*this).OduzmiOd(x, x.Znak());
			}
			brezultat.zavrsiRed(); 
			brezultat.zavrsiKorak();
		}
		void BcdBroj::SaberiSa (BcdBroj& x, char Znak)
		{
			string Prenos;  //cuvamo cifre koje predstavljaju prenos (potrebne za drugu fazu)
			string PrviZbir;  //Zbir prve faze sabiranja
	
			PrvaFazaSabiranja(Prenos, PrviZbir,x);
			
			brezultat << "Prvi operand je: ";	Alati::StampajBcdBroj(*this);
			brezultat << "\nDrugi operand je:";	Alati::StampajBcdBroj(x);
			
			brezultat << "\n ";			Alati::StampajBcdBroj(PrviZbir);
			brezultat << "sa prenosom\n ";		Alati::StampajBcdBroj(Prenos);
			fflush(stdout);
			brezultat << "\n ";
			
			brezultat.zavrsiKorak();		Alati::StampajBcdBroj(PrviZbir);
			
			brezultat << "\n";
			string KonacanZbir;			//Krajnji rezultat
			KonacanZbir.resize(PrviZbir.size());
			KonacanZbir = PrviZbir;
			
			DrugaFazaSabiranja(Prenos, PrviZbir, KonacanZbir);  //U okviru nje se vrse potrebna stampanja
			
			brezultat << Znak;					Alati::StampajBcdBroj(KonacanZbir);
		}
		
		void BcdBroj::PrevediCifru(const char cifra)  //fja prevodi pojedinacnu cifru u odgovarajuci binarni kod i dodaje je u _Broj
		{
			int br = cifra-'0'+_Visak;  //Prepravi:zbog toga sto radimo u visak 3, dodajemo 3
			int deljenik = 8;
			while (deljenik != 0)
			{
				if (br / deljenik >= 1)
				{
					_Broj += '1';
					br -= deljenik;
				}
				else
					_Broj += '0';
				
				deljenik /= 2;
			}
		}
		//Pomocna metoda koja se koristi kod druge faze sabiranja
		bool BcdBroj::VeciOd9 (const string& s) const
		{
			int cifra = 0;
			int pom = 8;
			int i=0;
			while (pom != 0)  //Svaka 4 bita oznacavaju jednu cifru; kroz ovu petlju se prolazi tacno 4 puta
			{
				cifra += (s[i++]-'0') * pom;
				pom /= 2;
			}
			cifra -= _Visak;
			return cifra > 9 ? true : false;
		}
