#ifndef __BCD_H
#define __BCD_H
#include <string>
#include <vector>
using namespace std;

class BcdBroj {

	public:
		BcdBroj();
		int Duzina() const;
		char VratiCifru (const int i) const;
		char Znak() const;
		operator string() const;
		void IzvrsiOperaciju (BcdBroj& x);
		void SaberiSa (BcdBroj& x, char Znak);
		virtual void KorigujBcdBroj(const int size) = 0;
		virtual void Skrati() = 0;
		virtual void OduzmiOd (BcdBroj& x, char Znak) = 0;
		
	protected:
		void PrevediCifru(const char cifra);
		bool VeciOd9 (const string& s) const;
		virtual void PrvaFazaOduzimanja(string& Prenos, string& PrvaRazlika, BcdBroj& x) = 0;
		virtual void PrvaFazaSabiranja(string& Prenos, string& PrviZbir, BcdBroj& x) = 0;
		virtual void DrugaFazaOduzimanja(string& Prenos, string& PrvaRazlika, string& KonacnaRazlika) = 0;
		virtual void DrugaFazaSabiranja(string& Prenos, string& PrviZbir, string& KonacanZbir) = 0;
		
		//Svi potrebni privatni podaci
		char _Znak;
		string _Broj;
		int _Visak;
		vector<string> _Rezultat;
		string _Komplement;
};
#endif
