#include "visak3.h"
#include "alati.h"
#include "rezultat.h"
#include <stdexcept>
using namespace std;

		BrojVisak3::BrojVisak3 (const string& x)  //Proveravamo moguci znak i od kojeg mesta krecemo da prevodimo cifre
		{
			if(!Alati::IspravanOperand(x))
				throw invalid_argument("Операнд није исправан");

			_Visak = 3;
			int pocetna=1;
			_Znak = '+';
			if (x[0] == '-')
				_Znak = '-';
			else if (x[0] == '+')
				_Znak = '+';
			else
				pocetna = 0;
			for (int i=pocetna; i<x.size(); i++)
				PrevediCifru(x[i]);  //prevodimo cifru po cifru i smestamo u string _Broj pomocu privatne metode
		}
		void BrojVisak3::KorigujBcdBroj(const int size)
		{
			int BrDodatihCifara = size - _Broj.size();
			string pomocni;
			for (int i=0; i<BrDodatihCifara; i++)//pogledaj dal ovo moze da se uradi na laksi nacin!
				if (i % 4 == 0 || i % 4 == 1) //dodajemo "0011"
					pomocni += '0';
				else
					pomocni += '1';
			pomocni += _Broj;
			_Broj = pomocni;
		}
		void BrojVisak3::Skrati()  //metoda brise eventualne vodece nule (0011)
		{
			int i=0;
			while (_Broj[i] == '0' && _Broj[i+1] == '0' && _Broj[i+2] == '1' && _Broj[i+3] == '1') 
				i += 4;  //pronalazimo sve cetvorke koje treba da izbrisemo
			if (i != 0)
			{
				string pomocni;
				for (; i<_Broj.size(); i++)  //u pomocni string smestamo novi broj
					pomocni += _Broj[i];
				_Broj = pomocni;  //ovde ga vracamo u _Broj
			}
		}
		void BrojVisak3::KorigujString(const int size, string &s) const
		{
			int BrDodatihCifara = size - s.size();
			string pomocni;
			for (int i=0; i<BrDodatihCifara; i++)//pogledaj dal ovo moze da se uradi na laksi nacin!
				if (i % 4 == 2 || i % 4 == 3) //dodajemo "0011"
					pomocni += '0';
				else
					pomocni += '1';
			pomocni += s;
			s = pomocni;
		}
		void BrojVisak3::OduzmiOd (BcdBroj& x, char Znak)
		{
			string Prenos;
			string PrvaRazlika;
			
			int duzina = Duzina();
			Prenos.resize(duzina);
			_Komplement.resize(duzina);
			
			for (int i=0; i<duzina; i++)
			{
				Prenos[i] = '0';
				_Komplement[i] = (int)(('2' - VratiCifru(i)) / 2) + '0';//Komplementiramo svaku cifru
			}
			
			Prenos[duzina-1] = '1';
			for (int i=duzina-1; i>=0; i--) //Dodajemo jedinicu
			{
				int CelaRazlika = _Komplement[i]-'0' + Prenos[i]-'0';
				_Komplement[i] = CelaRazlika % 2 + '0';
				if (i != 0)
					Prenos[i-1] = (int)(CelaRazlika/2) + '0';
			}
			PrvaFazaOduzimanja(Prenos,PrvaRazlika,x);
			
			brezultat << "Први операнд је: ";	Alati::StampajBcdBroj(x);
			brezultat << "\nДруги операнд је:";	Alati::StampajBcdBroj(*this);
			brezultat << "\nТо је исто као да вршимо сабирање бројева:\n";
												Alati::StampajBcdBroj(x);
			brezultat << '\n';					Alati::StampajBcdBroj(_Komplement);
			
			brezultat << "\n ";					Alati::StampajBcdBroj(PrvaRazlika);
			brezultat << "са преносом\n ";		Alati::StampajBcdBroj(Prenos);
			fflush(stdout);
			brezultat << "\n ";
			
			brezultat.zavrsiKorak();			Alati::StampajBcdBroj(PrvaRazlika);
			
			brezultat << "\n";
			string KonacnaRazlika;				//Krajnji rezultat
			KonacnaRazlika.resize(PrvaRazlika.size());
			KonacnaRazlika = PrvaRazlika;
			
			DrugaFazaOduzimanja(Prenos, PrvaRazlika, KonacnaRazlika);  //U okviru nje se vrse potrebna stampanja
			
			brezultat << Znak;					Alati::StampajBcdBroj(KonacnaRazlika);
		}

		void BrojVisak3::PrvaFazaOduzimanja(string& Prenos, string& PrvaRazlika, BcdBroj& x)
		{
			_Komplement.size() > x.Duzina() ? x.KorigujBcdBroj(_Komplement.size()) : KorigujString(x.Duzina(),_Komplement);
			int duzina = x.Duzina(); // svejedno, sada su iste duzine
			
			Prenos.resize(duzina);
			PrvaRazlika.resize(duzina); 
			for (int i=0; i<duzina; i++)
			{
				Prenos[i] = '0';
				if (i == 2 || i == 3) 		//incijalizujemo stringove da imaju pocetne nule (0011)
					PrvaRazlika[i] = '1';   //potrebno je da samo prvu cifru u stringu PrvaRazlika postavimo na nulu
				else						//ostale cifre ce biti obradjene tokom sabiranja
					PrvaRazlika[i] = '0';
			}
			for (int i=duzina-1; i>=0; i--)
			{
				int CeoZbir = _Komplement[i]-'0' + x.VratiCifru(i)-'0' + Prenos[i]-'0';
				PrvaRazlika[i] = CeoZbir % 2 + '0';
				if (i != 0)
					Prenos[i-1] = (int)(CeoZbir/2) + '0';
			}
		}
		void BrojVisak3::DrugaFazaOduzimanja(string& Prenos, string& PrvaRazlika, string& KonacnaRazlika)
		{
			for (int k=PrvaRazlika.size()/4; k!=0; k--) //Obradjujemo 4 po 4 binarne cifre
			{
				brezultat.zavrsiKorak();
				int TrenutniPrenos = 0;
				string pomocni;		//cuva trenutna 4 bita koji se obradjuju
				int i=k*4-1;		//krecemo od poslednjih 4 bita
				for (int j=3; j>=0; j--)
					pomocni += PrvaRazlika[i-j];
				
				if ((k == 1) || (Prenos[i-4] == '1')) //potrebna je korekcija "0011"
				{
					Alati::StampajBeline(5*k-4); brezultat << "0011" << "\n";
					
					for (int j=3; j>=0; j--)
					{
						int temp;
						if (j==2 || j==3)
							temp = pomocni[j]-'0' + 1 + TrenutniPrenos;
						else
							temp = pomocni[j]-'0' + TrenutniPrenos;
						KonacnaRazlika[i-3+j] = temp%2 + '0';
						TrenutniPrenos = (int)(temp/2);
					}
					Alati::StampajRed(5*k-4, KonacnaRazlika, i-3, 4);
				}
				else					//potrebna je korekcija "1101"
				{
					Alati::StampajBeline(5*k-4); brezultat << "1101" << "\n";
					
					for (int j=3; j>=0; j--)
					{
						int temp;
						if (j==0 || j==1 || j==3)
							temp = pomocni[j]-'0' + 1 + TrenutniPrenos;
						else
							temp = pomocni[j]-'0' + TrenutniPrenos;
						KonacnaRazlika[i-3+j] = temp%2 + '0';
						TrenutniPrenos = (int)(temp/2);
					}
					Alati::StampajRed(5*k-4, KonacnaRazlika, i-3, 4);
				}
			}
			brezultat.zavrsiKorak();
		}
		void BrojVisak3::PrvaFazaSabiranja(string& Prenos, string& PrviZbir, BcdBroj& x)
		{
			_Broj.size() > x.Duzina() ? x.KorigujBcdBroj(_Broj.size()) : KorigujBcdBroj(x.Duzina());
			int duzina = x.Duzina(); // svejedno, sada su iste duzine
			
			duzina += 4;  //povecavamo duzinu zbog stringa PrviZbir
			Prenos.resize(duzina);
			PrviZbir.resize(duzina); 
			for (int i=0; i<duzina; i++)
			{
				Prenos[i] = '0';
				if (i == 2 || i == 3) 	//incijalizujemo stringove da imaju pocetne nule (0011)
					PrviZbir[i] = '1';  //potrebno je da samo prvu cifru u stringu PrviZbir postavimo na nulu
				else					//ostale cifre ce biti obradjene tokom sabiranja
					PrviZbir[i] = '0';
			}
			for (int i=duzina-1; i>=4; i--)  //idemo do 4 a unutar petlje kasnije obradjujemo cifre
			{
				int CeoZbir = _Broj[i-4]-'0' + x.VratiCifru(i-4)-'0' + Prenos[i]-'0';
				PrviZbir[i] = CeoZbir % 2 + '0';
				Prenos[i-1] = (int)(CeoZbir/2) + '0';
				if (i==4)  //kad treba da obradimo prvu cifru koja je vec postavljena na "0011" 
				{
					int Prenos2 = Prenos[i-1] - '0';
					while (i>=2)
					{
						int pom = PrviZbir[i-1]-'0' + Prenos2;
						PrviZbir[i-1] = pom % 2 + '0';
						Prenos2 = (int)(pom / 2);
						i--;
					}
				}
			}
		}
		void BrojVisak3::DrugaFazaSabiranja(string& Prenos, string& PrviZbir, string& KonacanZbir)
		{
			for (int k=PrviZbir.size()/4; k!=1; k--) //Obradjujemo 4 po 4 binarne cifre
			{
				brezultat.zavrsiKorak();
				int TrenutniPrenos = 0;
				string pomocni;		//cuva trenutna 4 bita koji se obradjuju
				int i=k*4-1;		//krecemo od poslednjih 4 bita
				for (int j=3; j>=0; j--)
					pomocni += PrviZbir[i-j];
				
				
				if (Prenos[i-4] == '1') //potrebna je korekcija "0011"
				{
					Alati::StampajBeline(5*k-4); brezultat << "0011" << "\n";
					
					for (int j=3; j>=0; j--)
					{
						int temp;
						if (j==2 || j==3)
							temp = pomocni[j]-'0' + 1 + TrenutniPrenos;
						else
							temp = pomocni[j]-'0' + TrenutniPrenos;
						KonacanZbir[i-3+j] = temp%2 + '0';
						TrenutniPrenos = (int)(temp/2);
					}
					Alati::StampajRed(5*k-4, KonacanZbir, i-3, 4);
				}
				else					//potrebna je korekcija "1101"
				{
					Alati::StampajBeline(5*k-4); brezultat << "1101" << "\n";
					
					for (int j=3; j>=0; j--)
					{
						int temp;
						if (j==0 || j==1 || j==3)
							temp = pomocni[j]-'0' + 1 + TrenutniPrenos;
						else
							temp = pomocni[j]-'0' + TrenutniPrenos;
						KonacanZbir[i-3+j] = temp%2 + '0';
						TrenutniPrenos = (int)(temp/2);
					}
					Alati::StampajRed(5*k-4, KonacanZbir, i-3, 4);
				}
			}
			brezultat.zavrsiKorak();
		}
